#include "MPEGVStreamer.h"

static const char *subversion_id = "$Id: MPEGVStreamer.cpp 290 2004-03-25 18:50:42Z tkay $";

using namespace MIMD;

MPEGVStreamer::~MPEGVStreamer() 
{
   if(videoSource) Medium::close(videoSource);
   if(mpegDemux) Medium::close(mpegDemux);
}

bool MPEGVStreamer::moveToNextSource() 
{
   const Source &s = getSource();

   if(beforeFirst) {
      curItem = s.getPlayList().begin();
      beforeFirst = false;
   } else
      curItem++;

   // Check to see if we already supplied a source
   if(videoSource) Medium::close(videoSource);
   if(mpegDemux) Medium::close(mpegDemux);

   videoSource = NULL;
   mpegDemux = NULL;

   // Do the actual move

   if(curItem == s.getPlayList().end()) {
      if(s.isLooping()) 
         curItem = s.getPlayList().begin();
      else 
         return false;
   }

   FramedSource *fsrc;

   fsrc = fileSource = ByteStreamFileSource::createNew(*getEnvironment(), 
                                    curItem->getFileName().c_str());

   // We need to split the stream
   if(curItem->hasAudio() && curItem->hasVideo()) {
      mpegDemux = MPEG1or2Demux::createNew(*getEnvironment(), fileSource);
      fsrc = mpegDemux->newVideoStream();
   }

   videoSource = MPEG1or2VideoStreamFramer::createNew(*getEnvironment(), fsrc);

   return true;
}
