#ifndef MIMD_MPEGAS
#define MIMD_MPEGAS

#include "parser.h"
#include <liveMedia.hh>
#include "MediaStreamer.h"

namespace MIMD
{
   class MPEGAStreamer : public MediaStreamer
   {
      public:
         /**
          * Create a new streamer using parameters from a configuration
          * Source object.
          * @param MIMD::Souce The configuration for the streamer.
          */
         MPEGAStreamer(const Source &src) : MediaStreamer(src) {
            beforeFirst = true;
            audioSource = NULL;
            fileSource = NULL;
            mpegDemux = NULL;
         }
         virtual ~MPEGAStreamer();

         /**
          * Methods overriding MediaStreamer. @see MIMD::MediaStreamer.
          */
         virtual bool hasAudio() { return true; }
         virtual bool hasVideo() { return false; }
         virtual FramedSource *getAudioFSource() { return audioSource; }
         virtual FramedSource *getVideoFSource() { return NULL; }
         virtual bool moveToNextSource();
      private:
         list<MediaItem>::const_iterator curItem;
         FramedSource *audioSource;
         MPEG1or2Demux *mpegDemux;
         ByteStreamFileSource *fileSource;
         bool beforeFirst;
   };
};

#endif
